#include <stdlib.h>
#include <pthread.h>

struct Acct {
  int balance;
  pthread_mutex_t mutex;
};

struct Acct * new_acct() {
  struct Acct * ans = (struct Acct*)malloc(sizeof(struct Acct));
  ans->balance = 0;
  pthread_mutex_init(&ans->mutex,NULL);
  return ans;
}

int withdraw(struct Acct * a, int amt) {
  pthread_mutex_lock(&a->mutex);
  if(a->balance < amt) {
    pthread_mutex_unlock(&a->mutex);
    return 1; // 1==failure
  }
  a->balance -= amt;
  pthread_mutex_unlock(&a->mutex);
  return 0; // 0==success
}

int deposit(struct Acct * a, int amt) {
  pthread_mutex_lock(&a->mutex);
  a->balance += amt;
  pthread_mutex_unlock(&a->mutex);
  return 0; // 0==success
}

void free_account(struct Acct* a) {
  pthread_mutex_destroy(&a->mutex);
  free(a);
}
